Google: Veo 3.1 (Reference to Video) API Reference

About

Generate videos from reference image(s) and text using Google's Veo 3.1 model.

The prompt should describe how to animate between the first and last frame. Include:

  • Action: How the first and last frame should be animated
  • Style: Desired animation style
  • Camera motion (optional): How camera should move
  • Ambiance (optional): Desired mood and atmosphere

1. Calling the API

Setup your API Key

To begin using Infron, you first need to create an account and generate your API Key.

Once you have your API key, set it as an environment variable in your runtime environment. This allows your applications to securely access Infron’s API.

export INFRON_KEY="YOUR_API_KEY"

Submit a request

For long-running requests, you can poll for results.

curl https://media.onerouter.pro/v1/videos/generations \
  -H "Authorization: Bearer YOUR_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
  "model": "google/veo3.1/reference-to-video",
  "duration": "4s",
  "aspect_ratio": "16:9",
  "resolution": "720p",
  "generate_audio": true,
  "prompt": "A chimpanzee wearing overalls frolics in the grassy field, gently playing with the butterflies. In the background, a circus tent and carousel beckon.",
  "image_urls": ["https://storage.googleapis.com/infron_gcs/image%2Fplayground-inputs%2F15%2F20260529%2Fffcfefaa-e608-4e63-86ad-80f733e2c28b.png", "https://storage.googleapis.com/infron_gcs/image%2Fplayground-inputs%2F15%2F20260529%2F99ac9992-394d-4133-a097-f2504f6a3fac.png", "https://storage.googleapis.com/infron_gcs/image%2Fplayground-inputs%2F15%2F20260529%2Fbe373032-e5bb-4ffd-b520-ed93b79f227c.png"]
}'

Response with queue task id

The response will look like this:

{
  "code": 200,
  "message": "success",
  "data": {
    "task_id": "b421345894234a5297fb6328568d44f1",
    "object": "video",
    "model": "google/veo3.1/reference-to-video",
    "status": "created",
    "urls": {
      "query": "https://media.onerouter.pro/v1/videos/tasks/b421345894234a5297fb6328568d44f1"
    },
    "created_at": "2026-05-29 12:43:25.88"
  }
}

Fetch request status

You can fetch the status of a request to check if it is completed or still in progress.

curl https://media.onerouter.pro/v1/videos/tasks/{task_id} \
  -H "Authorization: Bearer YOUR_API_KEY" \
  -H "Content-Type: application/json" 

# For example
curl https://media.onerouter.pro/v1/videos/tasks/b421345894234a5297fb6328568d44f1 \
  -H "Authorization: Bearer YOUR_API_KEY" \
  -H "Content-Type: application/json"

Response with queue task status query

{
  "code": 200,
  "message": "success",
  "data": {
    "task_id": "b421345894234a5297fb6328568d44f1",
    "object": "video",
    "model": "google/veo3.1/reference-to-video",
    "status": "in_progress",
    "fail_reason": "",
    "submit_time": 1780058606,
    "start_time": 1780058606,
    "finish_time": 0,
    "outputs": [],
    "created_at": "2026-05-29 12:43:26"
  }
}

Possible statuses:

  • created
  • in_progress
  • processing
  • completed
  • failed

created -> in_progress → processing → completed | failed

Poll every 1-2 seconds until status is "completed" or "failed"

Get the result (when status is "completed")

Once the request is completed, you can fetch the result. See the Output Schema for the expected result format.

{
  "code": 200,
  "message": "success",
  "data": {
    "task_id": "b421345894234a5297fb6328568d44f1",
    "object": "video",
    "model": "google/veo3.1/reference-to-video",
    "status": "completed",
    "fail_reason": "",
    "submit_time": 1780058606,
    "start_time": 1780058606,
    "finish_time": 1780058659,
    "outputs": [
      "https://storage.googleapis.com/infron_gcs/video%2Fvideo_v2%2Foutput%2Foutput_3e414500-0cb3-4196-8c45-1a0d7fd39ae5.mp4"
    ],
    "usage": {
      "completion_tokens": 0,
      "duration": 8,
      "generate_audio": true,
      "output_count": 1,
      "prompt_tokens": 1,
      "request_num": 1,
      "resolution": "720p",
      "tokens": 1,
      "total_tokens": 1
    },
    "cost": {
      "total_cost": 3.2,
      "cost_details": {
        "prompt_cost": 0,
        "completion_cost": 0,
        "image_cost": 0,
        "video_cost": 3.2,
        "audio_cost": 0,
        "native_web_search_cost": 0,
        "plugin_web_search_cost": 0,
        "tools_cost": 0,
        "prompt_cache_read_cost": 0,
        "prompt_cache_write_cost": 0,
        "prompt_cache_write_5_min": 0,
        "prompt_cache_write_1_h": 0,
        "reasoning_cost": 0,
        "discount_rate": 1,
        "is_byok": false,
        "byok_cost": 0
      }
    },
    "created_at": "2026-05-29 12:43:26"
  }
}

2. Schema

Input

ParameterTypeRequiredDefaultRangeDescription
modelstringYes--Explore all modelsModel name.
promptstringYes----Text prompt for generation; Positive text prompt.
image_urlsarrayYes--1-3 image URLsThe URLs of the images to use as asset references for the generation.
aspect_ratiostringNo16:916:9, 9:16Aspect ratio of the generated video
durationstringNo4s8s, 4s, 6sDuration of the generated video
resolutionstringNo720p720p, 1080p, 4kResolution of the generated video
generate_audiobooleanNotruetrue, falseWhether to generate audio.
negative_promptstringNo----Negative prompt for the generation.
seedintegerNo-->=1The random seed to use for the generation.

Example request

curl https://media.onerouter.pro/v1/videos/generations \
  -H "Authorization: Bearer YOUR_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
  "model": "google/veo3.1/reference-to-video",
  "duration": "4s",
  "aspect_ratio": "16:9",
  "resolution": "720p",
  "generate_audio": true,
  "prompt": "A chimpanzee wearing overalls frolics in the grassy field, gently playing with the butterflies. In the background, a circus tent and carousel beckon.",
  "image_urls": ["https://storage.googleapis.com/infron_gcs/image%2Fplayground-inputs%2F15%2F20260529%2Fffcfefaa-e608-4e63-86ad-80f733e2c28b.png", "https://storage.googleapis.com/infron_gcs/image%2Fplayground-inputs%2F15%2F20260529%2F99ac9992-394d-4133-a097-f2504f6a3fac.png", "https://storage.googleapis.com/infron_gcs/image%2Fplayground-inputs%2F15%2F20260529%2Fbe373032-e5bb-4ffd-b520-ed93b79f227c.png"]
}'

Output

ParameterTypeRangeDescription
codeinteger--Status code of the request.
messagestring--Status message of the request.
dataobject--Data of the video task.
data.task_idstring--ID of the video task.
data.objectstring--Object type of the video task.
data.modelstring--Model name of the video task.
data.statusstringcreated, in_progress, processing, completed, failedStatus of the video task.
data.fail_reasonstring--Fail reason of the video task.
data.submit_timeinteger--Timestamp of the video task submission.
data.start_timeinteger--Timestamp of the video task start.
data.finish_timeinteger--Timestamp of the video task finish.
data.outputsarray--Outputs of the video task.
data.created_atstring--Timestamp of the video task creation.

Example output

{
  "code": 200,
  "message": "success",
  "data": {
    "task_id": "b421345894234a5297fb6328568d44f1",
    "object": "video",
    "model": "google/veo3.1/reference-to-video",
    "status": "completed",
    "fail_reason": "",
    "submit_time": 1780058606,
    "start_time": 1780058606,
    "finish_time": 1780058659,
    "outputs": [
      "https://storage.googleapis.com/infron_gcs/video%2Fvideo_v2%2Foutput%2Foutput_3e414500-0cb3-4196-8c45-1a0d7fd39ae5.mp4"
    ],
    "usage": {
      "completion_tokens": 0,
      "duration": 8,
      "generate_audio": true,
      "output_count": 1,
      "prompt_tokens": 1,
      "request_num": 1,
      "resolution": "720p",
      "tokens": 1,
      "total_tokens": 1
    },
    "cost": {
      "total_cost": 3.2,
      "cost_details": {
        "prompt_cost": 0,
        "completion_cost": 0,
        "image_cost": 0,
        "video_cost": 3.2,
        "audio_cost": 0,
        "native_web_search_cost": 0,
        "plugin_web_search_cost": 0,
        "tools_cost": 0,
        "prompt_cache_read_cost": 0,
        "prompt_cache_write_cost": 0,
        "prompt_cache_write_5_min": 0,
        "prompt_cache_write_1_h": 0,
        "reasoning_cost": 0,
        "discount_rate": 1,
        "is_byok": false,
        "byok_cost": 0
      }
    },
    "created_at": "2026-05-29 12:43:26"
  }
}

3. Detailed Pricing

ResolutionWithout AudioWith Audio
720p / 1080p$0.20/s$0.40/s
4K$0.40/s$0.60/s